Changes to bldpkg:

* Added err, info and warn functions to output necessary information in a specific format
* Added additional check for determining whether the shell really is a bash shell
* Added -v option and related code to increase compiler verbosity
* Discarded code to source a buildfile when attempting to validate it inside validatebuildfile function
* Further removed code to echo and pipe output to grep to validate build variables inside validatebuildfile function
* Added nopackagebuildfileerror function
* Renamed all variables in upper-case to lower-case inside runtime function
* Replaced $pkg/share/pkgconfig error with a warning and added supporting code to move it out of that directory and into $pkg/lib/
* Small miscellaneous fixes
This commit is contained in:
PktSurf 2022-10-22 14:50:54 +05:30
parent d28ae2b2e8
commit 42a5f99859

442
bldpkg
View file

@ -24,17 +24,27 @@
# -> Write code to log build output to a log file inside a particular directory
# -> Email the user about the outcome of the build?
# -> Increment warnings as they are issued during the build and show final warning total in the build summary
# -> Determine if the staging directory is empty at the end of the build, and if it is, error out
# -> Replace [INFO], [WARNING] and [ERROR] with suitable functions for efficient repetition
err() {
printf "**ERROR**\n$@\n"
exit 1
}
info() {
printf "[INFO] $@\n"
}
warn() {
printf "[WARNING]\n$@\n"
}
# Determine whether we are using bash version 4 and later. If not, exit.
if ((BASH_VERSINFO[0] < 4)) ; then
echo "[ERROR] bldpkg requires a minimum of bash shell version 4 to run"
exit 1
if [[ -z $BASH_VERSINFO ]] ; then
err "Is this really a GNU bash shell?"
elif ((BASH_VERSINFO[0] < 4)) ; then
err "Bldpkg requires a minimum of GNU bash shell version 4 to run"
fi
set -e
# Time when the build commenced. Note: elapsed time is logged by the runtime function way below.
# This output goes into package build summary.
commencedate=$(date '+%a, %d %b %Y, %T')
@ -90,6 +100,8 @@ Usage:
-s Display build summary. A summary is produced whenever a build is either
interrupted, exits cleanly or aborts due to a build error
-v Increase compiler verbosity
-x Invoke bash shell command trace mode. This one isn't akin to running
bash -x <script> but close enough, because the mode is inserted half-way
while bldpkg is running
@ -103,15 +115,12 @@ if [[ -f $HOME/.bldpkg.conf ]] ; then
elif [[ -f /etc/bldpkg.conf ]] ; then
source /etc/bldpkg.conf
else
echo "[ERROR] /etc/bldpkg.conf not found!"
exit 1
err "Bldpkg configuration file '/etc/bldpkg.conf' not found!"
fi
# Error out if globalccache and globalsccache are set in the /etc/bldpkg.conf
if [[ $globalccache = 1 ]] && [[ $globalsccache = 1 ]] ; then
echo "[ERROR] Please only enable either ccache or sccache in /etc/bldpkg.conf"
echo "[ERROR] at the same time, not both."
exit 1
err "Please only enable either ccache or sccache in /etc/bldpkg.conf at the same time, not both."
fi
# Function to validate the build file.
@ -120,65 +129,40 @@ validatebldfile() {
buildfile=$1
if [[ ! -f $buildfile ]] ; then
echo "[ERROR] No build file to validate from!"
exit 1
err "No build file to validate from!"
fi
# Start a subshell. We don't want the build file variables in the environment just yet.
(
source "$buildfile"
# If any of the following variables are not set in the build file, abort.
# $download variable is optional but recommended
for buildvariables in app version build homepage desc requires ; do
if [[ ! ${!buildvariables} ]] ; then
echo "[ERROR] Required variable '$buildvariables' is not set. Please check your build file."
exit 1
elif grep -E -q "$buildvariables='*'" "$buildfile" ; then
echo "[ERROR] Please dont use single quotes to define the \"${buildvariables}\" variable"
exit 1
fi
done
# Validate $app
if ! echo "$app" | grep -E -q '^[a-z0-9-]+$' ; then
echo "[ERROR] Only lower case, numeric characters and dash allowed in the 'app' variable in the build file."
exit 1
if ! grep -E -q 'app=[a-z0-9-]' "$buildfile" ; then
err "Only lower case, numeric characters and dash allowed in the 'app' variable in the build file."
# Validate $version
elif ! echo "$version" | grep -E -q '^[a-z0-9.]+$' ; then
echo "[ERROR] Only lower case, numeric characters and a period allowed in the 'version' variable in the build file."
exit 1
elif ! grep -E -q 'version=[a-z0-9.]' "$buildfile" ; then
err "Only lower case, numeric characters and a period allowed in the 'version' variable in the build file."
# Validate $homepage
elif ! echo "$homepage" | grep -E -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the 'homepage' variable in the build file."
exit 1
elif ! grep -E -q 'homepage="\(http|https|ftp)://' "$buildfile" ; then
err "Invalid URL in the 'homepage' variable in the build file."
# Validate $download, first the URL type
elif [[ -n $download ]]; then
if ! echo "$download" | grep -E -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the 'download' variable in the build file."
exit 1
elif grep -E -q 'download=' "$buildfile" ; then
if ! grep -E -q 'download="\(http|https|ftp)://' "$buildfile" ; then
err "Invalid URL in the 'download' variable in the build file."
fi
# Then check for single quotes
elif grep -E -q "download='*'" "$buildfile" ; then
echo "[ERROR] Single quotes disallowed in the 'download' variable in the build file"
exit 1
if grep -E -q "download='*'" "$buildfile" ; then
err "Single quotes disallowed in the 'download' variable in the build file"
fi
# Validate $desc using bash shell's ability to count variable length
elif [[ ${#desc} -gt 100 ]] ; then
echo "[ERROR] Package description should not exceed 100 characters in the build file."
exit 1
err "Package description should not exceed 100 characters in the build file."
# Check if build() function exists in the build file
elif ! grep -E -q '^build()' "$buildfile" ; then
echo "[ERROR] 'build()' function does not exist in your build file."
exit 1
elif ! grep -q '^build() {' "$buildfile" ; then
err "'build()' function does not exist in your build file."
fi
)
# End subshell
}
# Store the source directory path the build was initiated from
@ -194,13 +178,12 @@ rqfiles=( installpkg upgradepkg sha512sum patch find findmnt patch tput bc tar )
# Run a for loop to find the files
for requiredfile in "${rqfiles[@]}"; do
if [[ ! -x $(type -p "$requiredfile") ]] ; then
echo "[ERROR] Could not find required program '$requiredfile'!"
exit 1
err "Could not find required program '$requiredfile'!"
fi
done
# Function for providing handy arguments to users. Some will override bldpkg.conf.
while getopts ':def:ghj:o:sx' option; do
while getopts ':def:ghj:o:svx' option; do
case "$option" in
d) debug=1 ;; # Produce a debug build with -g3
e) extractprompt=0;
@ -211,27 +194,28 @@ while getopts ':def:ghj:o:sx' option; do
j) customcputhreads="$OPTARG" ;;
o) origbuildfile="$OPTARG" ;;
s) showsummary=1 ;; # Show build summary at the end of the build irrespective of the build status
v) getoptscompilerverbosity=1 ;;
x) set -xv ;; # Invoke bash's -x option for command tracing
*) help ;;
esac
done
nopackagebuildfileerror() {
err "No package build file to source from!
Was expecting '$buildfile' to be present inside this directory '$PWD'.
Try -f <build_file> if your build file has a different name (Not recommended)"
}
# The getopts builtin sets the OPTIND environment variable whose value is set to 1 if no argument
# is given. For every argument passed, the number is incremented by 1. In our case, if OPTIND equals
# 1, no argument was passed. We therefore expect a package build file to be present which will be then sourced.
if [[ $OPTIND = 1 ]] ; then
if [[ ! -f $buildfile ]] ; then
echo "[ERROR] No package build file to source from!"
echo "[ERROR] Was expecting '$buildfile' to be present inside this directory '$PWD'."
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
nopackagebuildfileerror
elif ! validatebldfile "$buildfile" ; then
err "'$buildfile' build file validation failed!"
else
if ! validatebldfile "$buildfile" ; then
echo "[ERROR] '$buildfile' Build file validation failed!"
exit 1
else
source "$buildfile"
fi
source "$buildfile"
fi
# If OPTIND is greater than 1, perform various checks and actions
@ -242,8 +226,7 @@ elif [[ $OPTIND -gt 1 ]] ; then
if [[ -n $customcputhreads ]] ; then
# And validate whether the value is a number
if ! echo "$customcputhreads" | grep -E -q '^[0-9]+$' ; then
echo "[ERROR] Invalid CPU job number '$customcputhreads'. Please provide a valid number."
exit 1
err "Invalid CPU job number '$customcputhreads'. Please provide a valid number."
fi
# Reset $customcputhreads as $cputhreads
@ -253,54 +236,41 @@ elif [[ $OPTIND -gt 1 ]] ; then
# If $origbuildfile is set and is a file, check if $setbuildfile and $origbuildfile are the same
if [[ -n $origbuildfile ]] ; then
if [[ ! -f $origbuildfile ]] ; then
echo "[ERROR] Original build file '$origbuildfile' does not exist!"
exit 1
fi
err "Original build file '$origbuildfile' does not exist!"
if [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
elif [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
if [[ $origbuildfile = "$setbuildfile" ]] ; then
echo "[ERROR] Original build file and alternate build file are the same!"
exit 1
err "Original build file and alternate build file are the same!"
fi
fi
if ! validatebldfile "$origbuildfile" ; then
echo "[ERROR] Alternative build file validation failed!"
exit 1
elif ! validatebldfile "$origbuildfile" ; then
err "Alternative build file validation failed!"
fi
fi
# If $setbuildfile is set and is a file, set buildfile to its value, source it and initialise the build
if [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
elif [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
buildfile="$setbuildfile"
if ! validatebldfile "$buildfile" ; then
echo "[ERROR] '$buildfile' validation failed!"
exit 1
err "'$buildfile' validation failed!"
else
source "$buildfile"
fi
# If $setbuildfile is set but a file passed as an argument is not found, give an error
elif [[ -n $setbuildfile ]] && [[ ! -f $setbuildfile ]] ; then
echo "[ERROR] '$setbuildfile' not found!"
exit 1
err "Build file '$setbuildfile' not found!"
# If the above two conditions don't meet, get the presumed $buildfile value as a file and source it
elif [[ -f "$buildfile" ]] ; then
if ! validatebldfile "$buildfile" ; then
echo "[ERROR] '$buildfile' validation failed!"
exit 1
err "'$buildfile' validation failed!"
else
source "$buildfile"
fi
# If even that file is not found, throw an error and exit
else
echo "[ERROR] No package build file to source from!"
echo "[ERROR] Was expecting '$buildfile' to be present inside this directory '$PWD'."
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
nopackagebuildfileerror
fi
fi
@ -311,14 +281,14 @@ unset OPTIND OPTARG
if [[ $genchecksum = 1 ]] ; then
# File types whose checksums will go into the new build file
echo "[INFO] Discarding any old sha512sums from '$buildfile'"
info "Discarding any old sha512sums from '$buildfile'"
sed -E -i \
-e '/^sha512sums=".*"$/d' \
-e '/^sha512sums="/,/"$/d' \
-e "/^sha512sums='.*'\$/d" \
"$buildfile"
echo "[INFO] Adding new sha512sums in '$buildfile'"
info "Adding new sha512sums in '$buildfile'"
printf 'sha512sums="\n' >> "$buildfile"
files=( *.tar.* *.zip *.t?z *.patch *.diff *.c *.h )
@ -333,23 +303,22 @@ if [[ $genchecksum = 1 ]] ; then
printf '"' >> "$buildfile"
if [[ $(find . -type d -maxdepth 1 -print0 | wc -l) -ge 1 ]]; then
echo "[WARNING] SHA512 checksums not generated for files inside directories!"
warn "SHA512 checksums not generated for files inside directories!"
fi
echo "[INFO] You may now run 'bldpkg' again"
info "You may now run 'bldpkg' again"
exit 0
fi
# Display the package and its version we are building
echo "[INFO] Building package '$app' version '$version' ..."
info "Building package '$app' version '$version' ..."
sleep 0.5
# Invoke auditd if useauditd is set to 1 in bldpkg.conf
if [[ $useauditd = 1 ]] ; then
if [[ ! -x /bin/auditd ]] ; then
echo "[ERROR] Program 'auditd' not found!"
exit 1
err "Program 'auditd' not found!"
fi
# First clear out the log file
@ -363,7 +332,7 @@ if [[ $useauditd = 1 ]] ; then
auditpid=$!
# Note: auditd writes about 6-8 lines for our setup when initialized.
echo "[INFO] /bin/auditd initialised."
info "/bin/auditd initialised."
fi
# Function to safely terminate auditd.
@ -371,13 +340,13 @@ terminateauditd() {
if [[ $useauditd = 1 ]] ; then
# Terminate auditd, log number of lines inside a variable
/bin/kill "$auditpid"
echo "[INFO] /bin/auditd stopped."
info "/bin/auditd stopped."
auditlogtermsize=$(wc -l < $auditlogfile)
if [[ $auditlogtermsize -gt 10 ]] ; then
echo "[WARNING] Auditd log file '$auditlogfile' is greater than 10 lines!"
echo "[WARNING] Highly recommend that you examine its file!"
warn "Auditd log file '$auditlogfile' is greater than 10 lines!
Highly recommend that you examine its file!"
sleep 5
fi
fi
@ -385,21 +354,18 @@ terminateauditd() {
# sha512sums variable is expected in every single package build file
if [[ -z $sha512sums ]] ; then
echo "[ERROR] SHA512 checksums don't exist in '$buildfile' !"
echo "[ERROR] Please run 'bldpkg -g' to add them"
exit 1
err "SHA512 checksums don't exist in '$buildfile'! Please run 'bldpkg -g' to add them"
fi
eval sums=\"\$sha512sums\"
echo "[INFO] Verifying SHA512 checksums against source files..."
info "Verifying SHA512 checksums against source files..."
IFS=$'\n'
for src in $sums; do
if ! echo $src | sha512sum -c ; then
echo "[ERROR] Checksums failed to match!"
exit 1
err "Checksums failed to match!"
fi
done
@ -413,38 +379,35 @@ applypatch() {
# Perform a simple check
if [[ -z $patchfile ]] ; then
echo "[ERROR] Please provide valid patch file name"
exit 1
err "Please provide valid patch file name"
elif [[ ! -f $patchfile ]] ; then
echo "[ERROR] Patch file '$patchfile' not found inside $srcdir!"
exit 1
err "Patch file '$patchfile' not found inside $srcdir!"
fi
# Get relative path of the patch file
relativepath=$(basename $patchfile)
echo "[INFO] Applying patch '$relativepath'.."
info "Applying patch '$relativepath'.."
# We use if/else to determine if the patch applied successfully
if ! patch -p1 < "$patchfile" ; then
echo "[ERROR] Failed to apply patch file '$patchfile'"
err "Failed to apply patch file '$patchfile'"
fi
}
# Do a preliminary package dependency check if $checkdependencies is set to 1 in bldpkg.conf
if [[ $checkdependencies = 1 ]] ; then
echo "[INFO] Parsing $app 's dependency list..."
info "Parsing $app 's dependency list..."
for packagedep in $requires; do
depcount=$(find /share/doc -type f -name "$packagedep.SMBuild" | wc -l)
# If count is 1, we are ok
if [[ $depcount = 1 ]] ; then
echo "[INFO] Found dependency '$packagedep'"
info "Found dependency '$packagedep'"
# If count is 0, we exit, because we are in trouble
elif [[ $depcount = 0 ]] ; then
echo "[ERROR] Did not find dependency '$packagedep'."
exit 1
err "Did not find dependency '$packagedep'"
# If count is greater than or equal to 2, we are in slightly less trouble
elif [[ $depcount -ge 2 ]] ; then
echo "[WARNING] Found multiple versions of '$packagedep' !"
warn "Found multiple versions of '$packagedep' !"
sleep 0.5
fi
done
@ -464,21 +427,18 @@ inarray() {
# Check if $parenttmp is set and is a directory
if [[ -z $parenttmp ]] ; then
echo "[ERROR] parenttmp variable not set in /etc/bldpkg.conf."
exit 1
err "parenttmp variable not set in /etc/bldpkg.conf."
elif [[ ! -d $parenttmp ]] ; then
echo "[ERROR] parenttmp variable set to '$parenttmp' in /etc/bldpkg.conf is not a directory."
exit 1
err "parenttmp variable set to '$parenttmp' in /etc/bldpkg.conf is not a directory."
fi
# Attempt to write to the $parenttmp directory. This directory is used for everything related to the
# build process outside the source directory $srcdir
if ! touch "$parenttmp/.smlinuxwritetest" ; then
echo "[ERROR] Parent temp directory '$parenttmp' is not writable!"
exit 1
err "Parent temp directory '$parenttmp' is not writable!"
else
# Discard the test file
rm -f "$parenttmp/.smlinuxwritetest"
rm "$parenttmp/.smlinuxwritetest"
fi
# If htmloutput is set to 1, echo $app, $version and $build as file names inside the parent build directory.
@ -488,7 +448,7 @@ if [[ $htmloutput = 1 ]] ; then
if [[ -n $autobuild ]] ; then
cat << EOF >> "$parenttmp/BUILDMONITOR"
<b>$commencedate | Building package # $currentpkgnumber / $totalpkgnumber: <i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b>
<b>$commencedate | Building package $currentpkgnumber / $totalpkgnumber: <i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b>
EOF
else
cat << EOF >> "$parenttmp/BUILDMONITOR"
@ -502,8 +462,7 @@ fi
# Validate compressor and set extension
validpkgextensions=( tgz tbz tlz txz )
if ! inarray "${pkgext}" "${validpkgextensions[@]}" ; then
echo "[ERROR] '$pkgext' is not a valid pkg extension for an SMLinux installer file."
exit 1
err "'$pkgext' is not a valid pkg extension for an SMLinux installer file"
fi
# Figure out the compression tool to be used based on the $pkgext variable set in bldpkg.conf.
@ -531,8 +490,7 @@ esac
# Borrowed from slackware's installpkg utility
if ! "$compressor" --help > /dev/null 2>&1 ; then
echo "[ERROR] '$compressor' Compressor validation failed."
exit 1
err "'$compressor' Compressor validation failed."
fi
# Validate the TMPFS directory if usetmpfs is set to 1 and tmpfsdir variable is set. If it fails,
@ -545,13 +503,13 @@ if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]]; then
fi
# Discard the file used to test the tmp directory
[[ -e "$tmpfsdir/.smlinuxtmpwritetest" ]] && rm -f "$tmpfsdir/.smlinuxtmpwritetest"
[[ -e "$tmpfsdir/.smlinuxtmpwritetest" ]] && rm "$tmpfsdir/.smlinuxtmpwritetest"
# Check the tmpfsdir for stale directories other than the current package about to be built. If found, issue a warning.
if [[ $(find "$tmpfsdir" -type d -maxdepth 1 -print0 | wc -l) -gt 1 ]]; then
if [[ $(find "$tmpfsdir" -type d -maxdepth 1 | wc -l) -gt 1 ]]; then
if [[ ! -d $app.src ]] || [[ ! -d package-$app ]] ; then
echo "[WARNING] TMPFS directory '$tmpfsdir' has stale directories from previous builds!"
sleep 5
warn "TMPFS directory '$tmpfsdir' has stale directories from previous builds!"
#sleep 5
fi
fi
fi
@ -567,10 +525,8 @@ if [[ $swapcheck = 1 ]]; then
swapcheck=$(grep "SwapFree" /proc/meminfo | awk '{print $2}')
if [[ $swapcheck -lt $swapsize ]]; then
echo "[ERROR] Insufficient swap to build '$app' which is listed"
echo "[ERROR] in '$packagesrequiringswap'. Kindly add/increase"
echo "[ERROR] swap size on this system and try again."
exit 1
err "Insufficient swap to build '$app' which is listed in '$packagesrequiringswap'.
Kindly add/increase swap size on this system and try again."
fi
fi
fi
@ -620,15 +576,13 @@ fi
if inarray "${pkg}" "${protecteddirectories[@]}" ; then
echo "############ ATTENTION ############"
echo "[ERROR] 'pkg' VARIABLE IS SET TO '$pkg' WHICH IS A PROTECTED DIRECTORY! EXITING!"
exit 1
err "'pkg' VARIABLE IS SET TO '$pkg' WHICH IS A PROTECTED DIRECTORY! EXITING!"
fi
# Also check tmp directory in advance
if inarray "${tmp}" "${protecteddirectories[@]}" ; then
echo "############ ATTENTION ############"
echo "[ERROR] 'tmp' VARIABLE IS SET TO '$tmp' WHICH IS A PROTECTED DIRECTORY! EXITING!"
exit 1
err "'tmp' VARIABLE IS SET TO '$tmp' WHICH IS A PROTECTED DIRECTORY! EXITING!"
fi
# Validate and export $cputhreads as MAKEFLAGS variable
@ -666,8 +620,7 @@ EOF
binaryoutput=$($parenttmp/$compiler-$maincompiler)
if [[ $binaryoutput != $randomnum ]] ; then
echo "FAILED!"
exit 1
err "FAILED!"
fi
rm "$parenttmp/$compiler-$maincompiler.c" "$parenttmp/$compiler-$maincompiler"
@ -680,20 +633,15 @@ EOF
if [[ $globaldistcc = 1 ]] ; then
# Check if distcc exists and is an executable
if [[ ! -x $distccbinpath ]]; then
echo "[ERROR] Oops! Distcc binary was not found but building with it"
echo '[ERROR] was requested! Either ensure distcc is in your $PATH or'
echo "[ERROR] disable this option in bldpkg.conf file."
exit 1
err "Distcc binary was not found but building with it was requested!
Either ensure distcc is in your $PATH or disable its option in bldpkg.conf file."
# Check if the symlinks are right
elif [[ ! $(echo "$PATH" | grep "$distccsympath") ]] ; then
echo "[ERROR] '$distccsympath' directory not found in your env PATH"
exit 1
err "'$distccsympath' directory not found in your env PATH"
elif [[ ! -d $distccsympath ]] ; then
echo "[ERROR] '$distccsympath' directory containing symlinks to distcc"
echo "[ERROR] does not exist! Kindly create it and create symlinks"
echo "[ERROR] based on instructions in bldpkg.conf!"
exit 1
err "'$distccsympath' directory containing symlinks to distcc does not exist!
Kindly create it and create symlinks based on instructions in bldpkg.conf!"
fi
# Trace symlinks to the binary
@ -701,13 +649,10 @@ if [[ $globaldistcc = 1 ]] ; then
if [[ -e $distccsympath/$f ]] && [[ -L $distccsympath/$f ]]; then
# We use "realpath" to follow the $distccsympath/$f symlink and act on the exit code.
if [[ $(realpath -e "$distccsympath/$f") != "$distccbinpath" ]] ; then
echo "[ERROR] $distccsympath/$f does not point to '$distccbinpath'. "
echo "[ERROR] Kindly fix this!"
exit 1
err "'$distccsympath/$f' does not point to '$distccbinpath'. Kindly fix this!"
fi
else
echo "[ERROR] Symlink '$f' either does not exist or is not a symlink inside '$distccsympath'."
echo "[ERROR] Kindly fix this! "
err "Symlink '$f' either does not exist or is not a symlink inside '$distccsympath'. Kindly fix this! "
exit 1
fi
@ -721,18 +666,18 @@ if [[ $globaldistcc = 1 ]] ; then
PATH="${PATH//$distccsympath:/}"
else
# netcat hosts inside $DISTCC_HOSTS by checking for an open port
echo "[INFO] Validating distcc hosts..."
info "Validating distcc hosts..."
# Check if we have nc
if [[ ! -x /bin/nc ]] ; then
echo "[WARNING] nc does not exist! Ignoring this..."
warn "nc does not exist! Ignoring this..."
else
# Remove the common options along with the slash and the numbers after it
hosts=$(echo "$DISTCC_HOSTS" | sed -e 's@/[a-z0-9]*@@g' -e 's@--randomize@@' -e 's@localhost@@' -e 's@,lzo@@g')
for host in ${hosts[@]} ; do
# We only run distccd on TCP port 3632
if ! /bin/nc -z -w 1 "$host" 3632 > /dev/null 2>&1 ; then
echo "[WARNING] Distcc host '$host' is OFFLINE"
echo "[WARNING] Rewriting DISTCC_HOSTS"
warn "Distcc host '$host' is OFFLINE!
Rewriting DISTCC_HOSTS"
DISTCC_HOSTS=$(echo "$DISTCC_HOSTS" | sed "s@$host/[a-z0-9,]*@@")
fi
done
@ -748,34 +693,25 @@ fi
# Validate everything related to ccache if globalccache is set
if [[ $globalccache = 1 ]]; then
if [[ ! -x $ccachebinpath ]] ; then
echo "[ERROR] Oops! ccache binary was not found but building with it"
echo '[ERROR] was requested! Either ensure ccache is in your $PATH or'
echo "[ERROR] disable this option in bldpkg.conf."
exit 1
err "Ccache binary was not found but building with it was requested!
Either ensure ccache is in your $PATH or disable this option in bldpkg.conf."
fi
if [[ ! $(echo "$PATH" | grep "$ccachesympath") ]] ; then
echo "[ERROR] '"$ccachesympath"' directory not found in your env PATH"
exit 1
err "'"$ccachesympath"' directory not found in your env PATH"
elif [[ ! -d $ccachesympath ]] ; then
echo "[ERROR] '$ccachesympath' directory containing symlinks to ccache"
echo "[ERROR] does not exist! Kindly create it and create symlinks"
echo "[ERROR] based on instructions in bldpkg.conf."
exit 1
err "'$ccachesympath' directory containing symlinks to ccache does not exist!
Kindly create it and create symlinks based on instructions in bldpkg.conf."
fi
for f in gcc g++ cc c++ ; do
if [[ -e $ccachesympath/$f ]] && [[ -L $ccachesympath/$f ]]; then
# We use "realpath" to follow the $ccachesympath/$f symlink and act on the exit code
if [[ $(realpath -e "$ccachesympath/$f") != "$ccachebinpath" ]] ; then
echo "[ERROR] '$ccachesympath/$f' does not point to '$ccachebinpath'. "
echo "[ERROR] Kindly fix this!"
exit 1
err "'$ccachesympath/$f' does not point to '$ccachebinpath'. Kindly fix this!"
fi
else
echo "[ERROR] Symlink '$f' either does not exist or is not a symlink inside '$ccachesympath'"
echo "[ERROR] Kindly fix this!"
exit 1
err "Symlink '$f' either does not exist or is not a symlink inside '$ccachesympath'! Kindly fix this!"
fi
validatecompiler ccache $ccachesympath $f
@ -796,20 +732,16 @@ fi
if [[ $globalsccache = 1 ]]; then
if [[ ! -x $sccachebinpath ]] ; then
echo "[ERROR] Oops! sccache binary was not found but building with it"
echo "[ERROR] was requested! Either ensure sccache is in your "'$PATH'" or"
echo "[ERROR] disable this option in bldpkg.conf."
err "Oops! sccache binary was not found but building with it was requested!
Either ensure sccache is in your '$PATH' or disable this option in bldpkg.conf."
exit 1
fi
if [[ ! $(echo "$PATH" | grep "$sccachepath") ]] ; then
echo "[ERROR] '"$sccachepath"' directory not found in your env PATH"
exit 1
err "'"$sccachepath"' directory not found in your env PATH"
elif [[ ! -d $sccachepath ]] ; then
echo "[ERROR] '$sccachepath' directory containing symlinks to ccache"
echo "[ERROR] does not exist! Kindly create it and create symlinks"
echo "[ERROR] based on instructions in bldpkg.conf."
exit 1
err "'$sccachepath' directory containing symlinks to ccache does not exist!
Kindly create it and create symlinks based on instructions in bldpkg.conf."
fi
for f in gcc g++ cc c++ ; do
@ -821,14 +753,10 @@ if [[ $globalsccache = 1 ]]; then
sccache_hardlink_file_inode_num=$(stat --printf '%i\n' $sccachepath/$f)
if [[ ! -e $sccachepath/$f ]] ; then
echo "[ERROR] '$f' either does not exist inside '"$sccachepath"'"
echo "[ERROR] Kindly fix this!"
exit 1
err "'$f' either does not exist inside '"$sccachepath"'. Kindly fix this!"
# If the hard link's inode number does not match the original binary's inode number, throw an error and exit
elif [[ $sccache_hardlink_file_inode_num != "$sccache_binary_inode_num" ]] ; then
echo "[ERROR] File '"$f"' inside '"$sccachepath"' is not a hard link!"
echo "[ERROR] Kindly fix this!"
exit 1
err "File '"$f"' inside '"$sccachepath"' is not a hard link! Kindly fix this!"
fi
validatecompiler sccache $sccachepath $f
@ -888,8 +816,7 @@ elif [[ $arch = x86_64 ]]; then
export builddist CFLAGS CXXFLAGS
else
echo "[ERROR] Sorry! '$arch' CPU architecture not supported by SMLinux!"
exit 1
err "Sorry! '$arch' CPU architecture not supported by SMLinux!"
fi
@ -903,6 +830,14 @@ if [[ -z $noautoconfsite ]] ; then
fi
fi
# If compilerverbosity is set in /etc/bldpkg.conf or if verbosity is set to 1 from getopts, set V and
# VERBOSE environment variables for make and cmake build systems to pick up.
if [[ $compilerverbosity = 1 ]] || [[ $getoptscompilerverbosity = 1 ]] ; then
V=1
VERBOSE=1
export V VERBOSE
fi
# Condition to reuse the autobuildtemp file if set from autobuild or make a new temporary file
if [[ -n $autobuildtemp ]]; then
tempfile="$autobuildtemp"
@ -919,8 +854,7 @@ compileonlyfor() {
if [[ $archname != "$archargument" ]]; then
echo ""
echo "[INFO] '$app' not supported on '$archname' and hence not"
echo "[INFO] not being built. Exiting."
echo "[INFO]'$app' not supported on '$archname' and hence not not being built. Exiting."
exit 0
fi
}
@ -938,36 +872,35 @@ mkandenterbuilddir() {
# Now create all essential build-related directories
mkdir -p "$tmp" "$pkg/install" "$pkgdocs" "$pkgdest"
echo "[INFO] Leaving source directory $srcdir"
echo "[INFO] Entering build directory $tmp"
info "Leaving source directory $srcdir"
info "Entering build directory $tmp"
cd "$tmp"
}
# Function to fix permissions inside the build directory
# To be invoked inside a package build file.
fixbuilddirpermissions() {
echo -n "[INFO] Fixing permissions in the newly-created build directory..."
info "Fixing permissions in the newly-created build directory..."
chown -R root.root .
find -L . -perm /111 -a \! -perm 755 -a -exec chmod 755 {} \+ -o \
\! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} \+ || true
echo " done."
}
# Function to calculate elapsed build time. runtime takes the $SECONDS variable as an argument. $SECONDS is an
# environment variable set by bash to show the number of whole seconds the shell has been running.
runtime() {
TIMER=$1
[[ -z $TIMER ]] && return 1
timer=$1
[[ -z $timer ]] && return 1
local DAY=$(( TIMER / 86400 ))
local HOUR=$(( (TIMER - (DAY * 86400)) / 3600 ))
local MINS=$(( (TIMER - (DAY * 86400) - (HOUR * 3600)) / 60 ))
local SECS=$(( TIMER - (DAY * 86400) - (HOUR * 3600) - (MINS * 60) ))
local day=$(( timer / 86400 ))
local hour=$(( (timer - (day * 86400)) / 3600 ))
local mins=$(( (timer - (day * 86400) - (hour * 3600)) / 60 ))
local secs=$(( timer - (day * 86400) - (hour * 3600) - (mins * 60) ))
if [[ $DAY -gt 0 ]]; then
echo -n "${DAY}d, ${HOUR}h ${MINS}m ${SECS}s"
if [[ $day -gt 0 ]]; then
echo -n "${day}d, ${hour}h ${mins}m ${secs}s"
else
echo -n "${HOUR}h, ${MINS}m ${SECS}s"
echo -n "${hour}h, ${mins}m ${secs}s"
fi
return 0
@ -996,8 +929,7 @@ preprunitservice() {
if [[ -f $srcdir/$1.run ]] ; then
cp "$srcdir/$1.run" "etc/service/$1/run"
else
echo "[ERROR] Runit service file '$1.run' does not exist!"
exit 1
err "Runit service file '$1.run' does not exist!"
fi
# If the second argument is "down", or if the second argument is "finish", create that file inside etc/service/$1/
@ -1020,7 +952,7 @@ preprunitservice() {
# Function to perform post-compile tasks.
# To be invoked inside a package build file.
mkfinalpkg() {
# Now we attempt to split the total time we'll get when making the summary into two times: compile
# time and packaging time. Here we store the value of $SECONDS variable the moment makefinalpkg is
# invoked. We use this value as the compile time, because this is the next function that's called
@ -1032,43 +964,41 @@ mkfinalpkg() {
# compiletimeb will run the runtime function against compiletimea and store the resulting output
compiletimeb=$(runtime $compiletimea)
echo "[INFO] Leaving build directory $tmp"
echo "[INFO] Entering staging directory $pkg"
info "Leaving build directory $tmp"
info "Entering staging directory $pkg"
cd "$pkg"
echo "[INFO] Performing packaging tasks..."
info "Performing packaging tasks..."
# Check if /lib64 was created inside $pkg
if [[ -d $pkg/lib64 ]] ; then
echo "[ERROR] '$app' has /lib64 directory. Musl does not support multilib."
echo "[ERROR] Please fix the build options and ensure the /lib64 is not created."
exit 1
err "'$app' has /lib64 directory. Musl does not support multilib.
Please fix the build options and ensure the /lib64 is not created."
fi
# Check if /usr and /sbin were created inside $pkg only if allowusrdir=1 is not set in the package build file
for directory in usr sbin ; do
if [[ -d $pkg/$directory ]] ; then
echo "[ERROR] '$app' has '$directory' directory which is a symlink to /bin on SMLinux."
echo "[ERROR] Please fix the build options and ensure '$directory' is not created."
exit 1
err "'$app' has '$directory' directory which is a symlink to /bin on SMLinux.
Please fix the build options and ensure '$directory' is not created."
fi
done
echo "[INFO] Copying post-install files..."
info "Copying post-install files..."
[[ -e $srcdir/doinst.sh ]] && cp "$srcdir/doinst.sh" "$pkg/install/"
# If /share/applications directory exists but there is no doinst.sh in the source directory, create one using cat
if [[ -d $pkg/share/applications ]] && [[ ! -e $srcdir/doinst.sh ]] ; then
echo "[INFO] Found /share/applications but couldn't find any doinst.sh in the source directory."
echo "[INFO] Creating one automatically that refreshes GTK cache."
info "Found /share/applications but couldn't find any doinst.sh in the source directory.
Creating one automatically that refreshes GTK cache."
cat << EOF >> "$pkg/install/doinst.sh"
[[ -x /etc/rc.d/rc.gtk ]] && /etc/rc.d/rc.gtk
EOF
# Or if /share/applications directory exists, and there is a doinst.sh file in the source directory, but there is no mention of rc.gtk, then too create one using cat
elif [[ -d $pkg/share/applications ]] && [[ -e $srcdir/doinst.sh ]] && ! grep -q 'rc.gtk' "$srcdir/doinst.sh" ; then
echo "[INFO] Found /share/applications but couldn't find any rc.gtk lines inside doinst.sh in the source directory."
echo "[INFO] Creating one automatically that refreshes GTK cache."
info "Found /share/applications but couldn't find any rc.gtk lines inside doinst.sh in the source directory.
Creating one automatically that refreshes GTK cache."
cat << EOF >> "$pkg/install/doinst.sh"
[[ -x /etc/rc.d/rc.gtk ]] && /etc/rc.d/rc.gtk
EOF
@ -1076,7 +1006,7 @@ EOF
# Compress and link manpages
if [[ -d "$pkg/share/man" ]]; then
echo "[INFO] Compressing and linking man pages..."
info "Compressing and linking man pages..."
( cd "$pkg/share/man"
for manpagedir in $(find . -type d -name "man*") ; do
( cd $manpagedir
@ -1091,7 +1021,7 @@ EOF
fi
# Remove libtool archive files
echo "[INFO] Discarding any libtool archive (.la) files..."
info "Discarding any libtool archive (.la) files..."
find "$pkg" -type f -name "*.la" -exec rm -v {} \;
# Provide a copy of the package build file as a source of reference for users
@ -1105,17 +1035,21 @@ EOF
# We don't want multiple directories for documentation. Detect if $pkg/share/doc/<app-name> was created.
# If it has been created, move its contents into $pkgdocs and discard the old doc directory.
if [[ -d "$pkg/share/doc/$app" ]] ; then
echo "[INFO] Found share/doc/$app documentation directory."
echo "[INFO] Moving its contents into share/doc/$app-$version/"
info "Found share/doc/$app documentation directory.
Moving its contents into share/doc/$app-$version/"
mv "$pkg/share/doc/$app/"* "$pkgdocs"/
rmdir "$pkg/share/doc/$app"
fi
# We'd like pkgconfig files to only go into /lib; some packages have other ideas.
if [[ -d $pkg/share/pkgconfig ]] ; then
echo "[ERROR] '$app' has created /share/pkgconfig directory!"
echo "[ERROR] Please fix its build file!"
exit 1
warn "Moving /share/pkgconfig directory created by '$app' into /lib"
(
cd $pkg
mkdir -p lib/pkgconfig
mv share/pkgconfig/* lib/pkgconfig/
rmdir share/pkgconfig
)
fi
# Normally we'd expect some debug symbols in the newly-produced binaries. But that isn't always the
@ -1146,7 +1080,7 @@ EOF
# If $preservestaticlibs is not set in the package build file, delete all static libraries
if [[ -z $preservestaticlibs ]] ; then
echo "[INFO] Discarding any static libraries..."
info "Discarding any static libraries..."
find "$pkg" -type f -print0 | xargs -0 file -m /etc/file/magic/archive | \
grep -E "current ar archive" | awk '{print $1}' | cut -d: -f1 | \
xargs rm -v 2>/dev/null || true
@ -1169,13 +1103,13 @@ EOF
# https://gist.github.com/ruario/9672717
# Create the SMLinux package
echo "[INFO] Generating SMLinux package..."
info "Generating SMLinux package..."
# If $disablepkgsymlinks is not set in the package build file, change any symlinks into shell script code. An example is base/initfs wherein
# we only want the doinst.sh file in the source directory to be copied, not manipulated.
if [[ -z $disablepkgsymlinks ]] ; then
if find . -type l | grep -qm1 .; then
echo "[INFO] Found symlinks, preparing install/doinst.sh..."
info "Found symlinks, preparing install/doinst.sh..."
find . -type l -printf '( cd %h ; rm -f %f )\n( cd %h ; ln -sf %l %f )\n' -delete > install/symlinks
if [[ -f install/doinst.sh ]]; then
printf '\n' | cat - install/doinst.sh >> install/symlinks
@ -1190,23 +1124,23 @@ EOF
pkgstatus=$?
echo ""
echo "[INFO] SMLinux package '$app-$version-$arch-$build.$pkgext' successfully generated in $pkgdest."
info "SMLinux package '$app-$version-$arch-$build.$pkgext' successfully generated in $pkgdest."
# Terminate auditd daemon
terminateauditd
# Terminate sccache
if [[ $globalsccache = 1 ]] ; then
echo "[INFO] Terminating sccache"
info "Terminating sccache"
/bin/sccache --stop-server
fi
echo "[INFO] Leaving staging directory $pkg"
info "Leaving staging directory $pkg"
# cd back to $srcdir when preservepackagedir is set to 0 to prevent this error:
# shell-init: error retrieving current directory: getcwd: cannot access parent directories:
# No such file or directory
echo "[INFO] Re-entering source directory $srcdir"
info "Re-entering source directory $srcdir"
cd "$srcdir"
@ -1254,7 +1188,7 @@ EOF
buildfilecleanup() {
# Discard all temporary files
rm -f "$parenttmp/BUILDING"
rm "$parenttmp/BUILDING"
# Autobuild discards $tempfile automatically, so only discard $tempfile if $autobuildtemp is unset
if [[ -z $autobuildtemp ]] ; then
@ -1477,11 +1411,11 @@ promptuser() {
# Extract package at the end of a build if autoextract is set to 1
if [[ $autoextract = 1 ]] && [[ -z $autobuild ]] && [[ -n $newpkglocation ]] ; then
echo "[INFO] Extracting package installer inside $srcdir/test..."
info "Extracting package installer inside $srcdir/test..."
mkdir -p "$srcdir/test"
tar xvf "$newpkglocation" -C "$srcdir/test"
echo ""
echo "[INFO] '$app' package installer file successfully extracted"
info "'$app' package installer file successfully extracted"
fi
# Prompt the user at the end of a build whether to extract contents of a newly-built installer
@ -1499,13 +1433,13 @@ promptuser() {
read -r -p "[NOTIFY] Old test directory, if it exists already, will be overwritten. (y/N) " yn
case "$yn" in
[Yy]* ) echo "[INFO] Wise choice :-) ";
[Yy]* ) info "Wise choice :-) ";
mkdir -p "$srcdir/test"
tar xvf "$newpkglocation" -C "$srcdir/test"
echo ""
echo "[INFO] '"$app"' package installer file successfully extracted"
info "'"$app"' package installer file successfully extracted"
break;;
*) echo "[INFO] Nope? Alright." ; break ;;
*) info "Nope? Alright." ; break ;;
esac
done
fi
@ -1519,10 +1453,10 @@ promptuser() {
read -r -p "[NOTIFY] Would you like to install/upgrade it? (y/N) " yn
case "$yn" in
[Yy]* ) echo "[INFO] Wise choice :-) "
[Yy]* ) info "Wise choice :-) "
upgradepkg --install-new "$newpkglocation"
break;;
*) echo "[INFO] Nope? Alright." ; exit 0 ;;
*) info "Nope? Alright." ; exit 0 ;;
esac
done
fi
@ -1536,7 +1470,7 @@ promptuser() {
# on receiving ctrl-c from the user during a manual build.
interruptoutput() {
echo ""
echo "[INFO] Caught Keyboard Interrupt"
info "Caught Keyboard Interrupt"
wasinterrupted="1"
# Restore terminal colours
@ -1547,7 +1481,7 @@ interruptoutput() {
# Terminate sccache
if [[ $globalsccache = 1 ]] ; then
echo "[INFO] Terminating sccache"
info "Terminating sccache"
/bin/sccache --stop-server
fi